class Account01 {
	private int deposit = 10000;

	synchronized void withdraw(String message, int amount){
		System.out.println(message + " : 引き出し前 " + deposit);
		if(deposit < amount){
			System.out.println(message + " -> 預金が不足しています");
		}else{
			try{
				Thread.sleep(500);
			}catch(InterruptedException ex){
			}
			deposit -= amount;
			System.out.println(message + " : 引き出し後 " + deposit);
		}
	}
}
class Owner01 implements Runnable {
	private String name;
	private Account01 account;

	Owner01(String name, Account01 account){
		this.name = name;
		this.account = account;
	}
	public void run(){
		for(int i = 1; i <= 5; i++){
			account.withdraw(name + "-" + i, 3000);
		}
	}
}
class Exer15_03 {
	public static void main(String[] args){
		Account01 account = new Account01();
		new Thread(new Owner01("太郎", account)).start();
		new Thread(new Owner01("\t\t花子", account)).start();
	}
}
